<template>
      <!--
      <div class="row mb-3">
        <div class="col text-end">          
          <button class="btn btn-principal p-1 px-2 mx-2" alt="Exportar a PDF" title="Exportar a PDF"
            @click="exportar('.pdf')">
            <i class="bi bi-filetype-pdf mx-1 fonts-sm" v-html='"&nbsp;&nbsp;Generar PDF"'></i>
          </button>
          <button class="btn btn-principal p-1 px-2 mx-2" alt="Exportar a Excel" title="Exportar a Excel"
            @click="exportar('.xls')">
            <i class="bi bi-file-earmark-spreadsheet mx-1 fonts-sm" v-html='"&nbsp;&nbsp;Generar Excel"'></i>
          </button>        
          <button class="btn btn-secondary p-1 px-2 mx-2" alt="Agregar beca" title="Agregar beca" @click="abrirABM()">
            <i class="bi bi-plus-square mx-1 fonts-sm" v-html='"&nbsp;&nbsp;Nueva"'></i>
          </button>          
        </div>
      </div>
      -->
    <div >
          <table class="table table-striped" v-if="becasStore.becas.length > 0">
            <thead>
              <tr class="bg-princial text-light fs-5 px-5 text-uppercase text-center align-middle">
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Becario"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Doc. Becario"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Apoderado"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Doc. Apoderado"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"F. Inicio"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"F. Fin"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Importe"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Solicitante"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Mes Certif."'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Visado"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"F. Vencim."'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"CBU"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Estado"'></th>
                <th scope="col" style="padding-bottom: 7px !important;" v-text='"Acciones"'></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="beca in becasStore.becas" :key="beca.id_beca" class="fs-6 px-5 align-middle" :class='{ "table-danger": esBaja(beca) }' >
                <td v-text="concatMostrar(beca.apellido_becario, beca.nombres_becario)"></td>
                <td v-text="concatMostrar(beca.d_t_doc_becario, beca.n_doc_becario)"></td>
                <td v-text="concatMostrar(beca.apellido_apoderado, beca.nombres_apoderado)"></td>
                <td v-text="concatMostrar(beca.d_t_doc_apoderado, beca.n_doc_apoderado)"></td>
                <td class="text-center" v-text="fechaMostrar(beca.f_ingreso)"></td>
                <td class="text-center" v-text="fechaMostrar(beca.f_egreso)"></td>
                <td class="text-right" v-text="importeMostrar(beca.importe)"></td>
                <td v-text="concatMostrar(beca.apellido_solicitante, beca.nombres_solicitante)">
                </td>
                <td class="text-center" v-text="mesMostrar(beca.mes_certif)"></td>
                <td class="text-center" v-text="beca.d_visado"></td>
                <td class="text-center" v-text="fechaMostrar(beca.f_vencim_v)"></td>
                <td v-text="beca.cbu_completo"></td>
                <td v-text="beca.d_estado"></td>
                <td class="text-center">
                  <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mx-1" alt="Ver/editar beca"
                    title="Ver/editar beca" @click="abrirABM(beca)">
                    <i class="bi bi-pencil-square text-light"></i>
                  </button>
                </td>
              </tr>
            </tbody>
          </table>
       
          <div v-else class="alert alert-secondary text-center" role="alert">
            No se ha encontrado ninguna beca en el sistema.
          </div>
        </div>
</template>

<script setup lang="ts">
// Librerías
import { DateTime } from "luxon";
import type { PropType } from "vue";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
// Entidades
import type Beca from "@/entities/becas/Beca";
// Stores
import { useBecasStore } from "@/stores/becas/becas";
import { isEmpty } from "@hcd-bsas/vue3-components";

const becasStore = useBecasStore();

const emit = defineEmits(["abrirABM"]);

const concatMostrar = (cadena_1: string | null, cadena_2: string | null) => (!isEmpty(cadena_1) && !isEmpty(cadena_2)) ? cadena_1!.concat(' ', cadena_2!) : null;
const fechaMostrar = (fecha: string | undefined) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha!).toFormat('dd/MM/yyyy') : null;
const mesMostrar = (mes: number | null) => (mes !== null) ? DateTime.fromObject({ month: mes }, { locale: 'es-AR' }).toFormat('MM (MMMM)') : "";
const importeMostrar = (importe: number) => Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe);

function esBaja(beca: Beca): boolean {
  return (beca.estado === "B");
}

function abrirABM(beca: Beca) {
  const parametros = {
    id_beca: beca.id_beca,
    id_tabla_sol: beca.id_tabla_sol
  }
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (isEmpty(parametros.id_beca)) {
    swal.html = 'La beca seleccionada no posee un ID v&aacute;lido. Por favor, avise al Administrador.';
  } else if (isEmpty(parametros.id_tabla_sol)) {
    swal.html = 'La beca seleccionada no posee un solicitante v&aacute;lido. Por favor, avise al Administrador.';
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  emit('abrirABM', parametros);
}

/*
function exportar(formato: string) {

}
*/
</script>
